
var gautocopy_lastSelection = null;

window.addEventListener("load",function() {initAutoCopyStatus();} ,false);
window.addEventListener("focus",function() {resetAutoCopyStatus();} ,false);


function autocopyContextHide() {
	var cm = gContextMenu;
	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');


	if(autocopyPrefs.getBoolPref("optContextMenuItem")){
		AutocopyFirebirdcontextmenuitem.hidden = ( cm.onImage || cm.onLink || cm.onTextInput );
		//|| cm.onLink || cm.onImage || cm.onTextInput );
	}
	else{
	    AutocopyFirebirdcontextmenuitem.hidden = true;
	}
}



function setAutoCopyStatus()
{
	if(autocopyPrefs.getBoolPref("optStatusBar")){
		var autocopy = document.getElementById('autocopy-status');
		var autocopystatusimage = document.getElementById('autocopy-status-image');
		var tooltip = document.getElementById('autocopy-tooltip-value');

		if(autocopy && autocopystatusimage)
		{
			autocopystatusimage.setAttribute("src", "chrome://autocopy/skin/AutoCopyEnabled.png");
		    	var strings = document.getElementById("autocopyStrings");
			tooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
		}
	}

}



function initAutoCopyStatus() 
{
        initPreferences();
	
	document.getElementById("cmd_selectAll").setAttribute("oncommand", "goDoCommand('cmd_selectAll'); AutocopySelectAll();");


    	var strings = document.getElementById("autocopyStrings");

	var autocopyLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{0FED7D55-65D4-47b6-A6DE-9A4ADB55355F}.");
	var autocopylocaledescription = strings.getString("autocopy-description");
	var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
	str.data = autocopylocaledescription;
	autocopyLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
  

	var autocopyStatusBarButton = document.getElementById('autocopy-status');
	var autocopyStatusBarButtonImage = document.getElementById('autocopy-status-image');
	var autocopyStatusBarButtonTooltip = document.getElementById('autocopy-tooltip-value');
	if(autocopyStatusBarButton && autocopyStatusBarButtonImage)
	{

		if(autocopyPrefs.getBoolPref("optStatusBar")){
        	    if(autocopyStatusBarButton.collapsed)
		    {
        	    	   autocopyStatusBarButton.collapsed = false;
		    }
        	}
        	else{
        	    if(!autocopyStatusBarButton.collapsed)
		    {
        	    	   autocopyStatusBarButton.collapsed = true;
		    }
        	}
	

		if (autocopyPrefs.getIntPref("StatusBarState") == 0)
	        {
			 if(autocopyPrefs.getBoolPref("optStatusBar")){
		                 autocopyStatusBarButton.setAttribute("status", "disabled");
					autocopyStatusBarButtonImage.setAttribute("src", "chrome://autocopy/skin/AutoCopyDisabled.png");
	        	         autocopyStatusBarButtonTooltip.setAttribute("value", strings.getString("statusbar-tooltip-disabled"));
	        	 }
		}
		else
		{
			 if(autocopyPrefs.getBoolPref("optStatusBar")){
	                 	autocopyStatusBarButton.setAttribute("status", "enabled");
				autocopyStatusBarButtonImage.setAttribute("src", "chrome://autocopy/skin/AutoCopyEnabled.png");
	                 	autocopyStatusBarButtonTooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
			 }
		}

	}




	var AutocopyFirebirdmenuitem = document.getElementById('autocopy-firebirdmenuitem');
	var AutocopyFirebirdmenuitemseparator = document.getElementById('autocopy-firebirdmenuitemseparator');
	if(AutocopyFirebirdmenuitem)
	{
		if (autocopyPrefs.getIntPref("StatusBarState") == 0)
	        {
	                 AutocopyFirebirdmenuitem.setAttribute("checked", false);
		}
		else
		{
	                 AutocopyFirebirdmenuitem.setAttribute("checked", true);
		}

	        if(autocopyPrefs.getBoolPref("optEditMenuItem")){
		    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", false);
	            AutocopyFirebirdmenuitem.setAttribute("hidden", false);
	        }
	        else{
		    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", true);
	            AutocopyFirebirdmenuitem.setAttribute("hidden", true);
	        }
	}

	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');
	if(AutocopyFirebirdcontextmenuitem)
	{
		if (autocopyPrefs.getIntPref("StatusBarState") == 0)
		{
			AutocopyFirebirdcontextmenuitem.setAttribute("checked", false);
		}
		else
		{
			 AutocopyFirebirdcontextmenuitem.setAttribute("checked", true);
		}
		
		if(document.getElementById("contentAreaContextMenu"))
		{
			document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",autocopyContextHide,false);
	        }	
	}


	var Autocopykeytoggleautocopyenabled = null;
	if(document.getElementById('firebirdkey-toggle-autocopyenabled'))
		Autocopykeytoggleautocopyenabled = document.getElementById('firebirdkey-toggle-autocopyenabled');
	if(document.getElementById('mozillakey-toggle-autocopyenabled'))
		Autocopykeytoggleautocopyenabled = document.getElementById('mozillakey-toggle-autocopyenabled');
	if(document.getElementById('thunderbirdkey-toggle-autocopyenabled'))
		Autocopykeytoggleautocopyenabled = document.getElementById('thunderbirdkey-toggle-autocopyenabled');

	if(Autocopykeytoggleautocopyenabled)
	{
	        if(autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled")){
	    
	            var optModifiers = "";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAccel"))
	                optModifiers = optModifiers + ",accel";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyMeta"))
	                optModifiers = optModifiers + ",meta";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyCtrl"))
	                optModifiers = optModifiers + ",control";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyShift"))
	                optModifiers = optModifiers + ",shift";
	            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAlt"))
	                optModifiers = optModifiers + ",alt";
	                
	            optModifiers.replace(/^\,/,"");
	        
	            var optKey = autocopyPrefs.getCharPref("optKeyboardShortcutKey");
	            if(optKey.match(/^[A-Z]$/i)){
	                Autocopykeytoggleautocopyenabled.setAttribute("key", optKey);
	                Autocopykeytoggleautocopyenabled.setAttribute("keycode", "");
	            }
	            else{
	                Autocopykeytoggleautocopyenabled.setAttribute("key", "");
	                Autocopykeytoggleautocopyenabled.setAttribute("keycode", optKey);
	            }
	            
	            Autocopykeytoggleautocopyenabled.setAttribute("modifiers", optModifiers);
	            Autocopykeytoggleautocopyenabled.setAttribute("disabled", false);
	        }
	        else{
	            Autocopykeytoggleautocopyenabled.setAttribute("disabled", true);
	        }
	}	



	PasteOnMiddleClickStatusbarOption =  document.getElementById('autocopy-statusbar-PasteOnMiddleClick');
	if(PasteOnMiddleClickStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optPasteOnMiddleClick"))
		{
			PasteOnMiddleClickStatusbarOption.setAttribute("checked", true);
		}
		else
		{
			PasteOnMiddleClickStatusbarOption.setAttribute("checked", false);
		}
	}

	EnableInTextBoxesStatusbarOption =  document.getElementById('autocopy-statusbar-EnableInTextBoxes');
	if(EnableInTextBoxesStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
		{
			EnableInTextBoxesStatusbarOption.setAttribute("checked", true);
		}
		else
		{
			EnableInTextBoxesStatusbarOption.setAttribute("checked", false);
		}
	}

	AutocopyContextMenuStatusbarOption =  document.getElementById('autocopy-statusbar-AutocopyContextMenu');
	if(AutocopyContextMenuStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optContextMenu"))
		{
			AutocopyContextMenuStatusbarOption.setAttribute("checked", true);
		}
		else
		{
			AutocopyContextMenuStatusbarOption.setAttribute("checked", false);
		}
	}

	StatusbarBlinkStatusbarOption =  document.getElementById('autocopy-statusbar-StatusbarBlink');
	if(StatusbarBlinkStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optStatusbarBlink"))
		{
			StatusbarBlinkStatusbarOption.setAttribute("checked", true);
		}
		else
		{
			StatusbarBlinkStatusbarOption.setAttribute("checked", false);
		}
	}

	StatusbarDeselectAfterCopy =  document.getElementById('autocopy-statusbar-DeselectAfterCopy');
	if(StatusbarDeselectAfterCopy)
	{
		if (autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
		{
			StatusbarDeselectAfterCopy.setAttribute("checked", true);
		}
		else
		{
			StatusbarDeselectAfterCopy.setAttribute("checked", false);
		}
	}






}



function resetAutoCopyStatus()
{
    initAutoCopyStatus()
}


function initPreferences(){

	if (!autocopyPrefs.prefHasUserValue("StatusBarState"))
		autocopyPrefs.setIntPref("StatusBarState", 1)

	if (!autocopyPrefs.prefHasUserValue("optPasteOnMiddleClick"))
		autocopyPrefs.setBoolPref("optPasteOnMiddleClick", true);

	if (!autocopyPrefs.prefHasUserValue("optDeselectAfterCopy"))
	{
		if(navigator.vendor.match(/Thunderbird/i))
		{
			autocopyPrefs.setBoolPref("optDeselectAfterCopy", false);
		}
		else
		{
			autocopyPrefs.setBoolPref("optDeselectAfterCopy", false);
		}
	}


	if (!autocopyPrefs.prefHasUserValue("optCopyWithoutFormating"))
		autocopyPrefs.setBoolPref("optCopyWithoutFormating", false);

	if (!autocopyPrefs.prefHasUserValue("optStatusBar"))
		autocopyPrefs.setBoolPref("optStatusBar", true);

	if (!autocopyPrefs.prefHasUserValue("optStatusbarBlink"))
		autocopyPrefs.setBoolPref("optStatusbarBlink", true);

	if (!autocopyPrefs.prefHasUserValue("optEditMenuItem"))
		autocopyPrefs.setBoolPref("optEditMenuItem", false);
	if (!autocopyPrefs.prefHasUserValue("optContextMenuItem"))
		autocopyPrefs.setBoolPref("optContextMenuItem", false);
	if (!autocopyPrefs.prefHasUserValue("optEnableInTextBoxes"))
		autocopyPrefs.setBoolPref("optEnableInTextBoxes", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutEnabled"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutEnabled", false);

	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAccel"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAccel", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyMeta"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyMeta", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyCtrl"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyCtrl", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyShift"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyShift", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAlt"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAlt", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKey"))
		autocopyPrefs.setCharPref("optKeyboardShortcutKey", "C");
}




function switchautocopystatusstate()
{
        if (autocopyPrefs.getIntPref("StatusBarState") == 0)
        {
		autocopyPrefs.setIntPref("StatusBarState", 1);
        }
        else
        {
		autocopyPrefs.setIntPref("StatusBarState", 0);
        }
        initAutoCopyStatus();
}



// prefs
var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");

if (!autocopyPrefs.prefHasUserValue("StatusBarState"))
	autocopyPrefs.setIntPref("StatusBarState", 1)


window.onmouseup = autocopyOnMouseUp;
window.onkeyup = onKeyUpCheck;


function onKeyUpCheck(e)
{
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		autocopyOnMouseUp(e);
	}
}


function autocopyOnMouseUp(e)
{
   
	var targetclassname = e.target.toString();
	if(autocopyPrefs.getIntPref("StatusBarState") == 1)
	{
		if (!targetclassname.match(/object XUL/i))
		{
			if(!targetclassname.match(/SelectElement|OptionElement/i))
			{
				if(!targetclassname.match(/InputElement|TextAreaElement/i))
				{
					if((autocopy_getSelection().length > 0) && (gautocopy_lastSelection != autocopy_getSelection()))
					{
						//were going to copy
						gautocopy_lastSelection = autocopy_getSelection();
						if(autocopyPrefs.getBoolPref("optCopyWithoutFormating"))
						{
							copyplaintext();
						}
						else
						{
							goDoCommand('cmd_copy');
						}
						if(autocopyPrefs.getBoolPref("optStatusbarBlink"))
						{
							AutocopyBlinkStatusbarButton(3);
						}
						if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
						{
							Autocopy_DeselectAfterCopy();
						}
					}
				}
				if (targetclassname.match(/InputElement|TextAreaElement/i) && autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
				{
					if(((e.target.selectionEnd - e.target.selectionStart) > 0) && (gautocopy_lastSelection != autocopy_getSelection()))
					{
						//were going to copy
						gautocopy_lastSelection = autocopy_getSelection();
						if(autocopyPrefs.getBoolPref("optCopyWithoutFormating"))
						{
							copyplaintext();
						}
						else
						{
							goDoCommand('cmd_copy');
						}
						if(autocopyPrefs.getBoolPref("optStatusbarBlink"))
						{
							AutocopyBlinkStatusbarButton(3);
						}
						if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
						{
							Autocopy_DeselectAfterCopy();
						}
					}
				}
			}
		}
   	}

	if(autocopyPrefs.getBoolPref("optPasteOnMiddleClick"))
	{

		if(e.button == 1)
		{
			var doPaste = false;
			if(e.target.toString().match(/HTML.*Element/i))
			{
				if(!e.target.toString().match(/HTMLAnchorElement/i))
				{
					doPaste = true;
				}
				if(e.target.toString().match(/HTMLImageElement/i))
				{
					if(e.target.src.match(/chrome\:\/\/.*autoscroll/i))
					{
						doPaste = true;
					}
				}
			}	
			if(e.target.inputField)
			{
				if(e.target.inputField.toString().match(/InputElement|TextAreaElement/i))
				{
					doPaste = true;
				}
			}	
			if(e.target.mTextbox)
			{
				if(e.target.mTextbox.inputField)
				{
					if(e.target.mTextbox.inputField.toString().match(/InputElement|TextAreaElement/i))
					{
						doPaste = true;
					}
				}
			}
			if(doPaste)
			{
				goDoCommand('cmd_paste');
			}
		}
	}
}


function AutocopySelectAll()
{
	var targetclassname = "";
	if(document.commandDispatcher.focusedElement)
	{	
		targetclassname = document.commandDispatcher.focusedElement.toString();
	}

	if(autocopyPrefs.getIntPref("StatusBarState") == 1)
	{
		if (!targetclassname.match(/object XUL/i))
		{
			if(!targetclassname.match(/SelectElement|OptionElement/i))
			{
				if(!targetclassname.match(/InputElement|TextAreaElement/i))
				{
					if(autocopy_getSelection().length > 0)
					{
						//were going to copy
						gautocopy_lastSelection = autocopy_getSelection();
						if(autocopyPrefs.getBoolPref("optCopyWithoutFormating"))
						{
							copyplaintext();
						}
						else
						{
							goDoCommand('cmd_copy');
						}
						if(autocopyPrefs.getBoolPref("optStatusbarBlink"))
						{
							AutocopyBlinkStatusbarButton(3);
						}
						if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
						{
							Autocopy_DeselectAfterCopy();
						}
					}
				}
				if (targetclassname.match(/InputElement|TextAreaElement/i) && autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
				{
					if(((e.target.selectionEnd - e.target.selectionStart) > 0) && (gautocopy_lastSelection != autocopy_getSelection()))
					{
						gautocopy_lastSelection = autocopy_getSelection();
						if(autocopyPrefs.getBoolPref("optCopyWithoutFormating"))
						{
							copyplaintext();
						}
						else
						{
							goDoCommand('cmd_copy');
						}
						if(autocopyPrefs.getBoolPref("optStatusbarBlink"))
						{
							AutocopyBlinkStatusbarButton(3);
						}
						if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
						{
							Autocopy_DeselectAfterCopy();
						}
					}
				}
			}
		}
	}
}

function Autocopy_DeselectAfterCopy()
{
	if(autocopyPrefs.getBoolPref("optStatusbarBlink"))
	{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		try
		{
			var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
			var Selection = winWrapper.getSelection();
		}
		catch(e)
		{
			var Selection = focusedWindow.getSelection();
		}
		var SelectionfocusNode = Selection.focusNode;
		var SelectionfocusOffset = Selection.focusOffset;
		Autocopy_DeselectAfterCopy_CollapseSelection()
		setTimeout(Autocopy_DeselectAfterCopy_ExtendSelection, 25, SelectionfocusNode, SelectionfocusOffset); 
		setTimeout(Autocopy_DeselectAfterCopy_CollapseSelection, 50); 
		setTimeout(Autocopy_DeselectAfterCopy_ExtendSelection, 75, SelectionfocusNode, SelectionfocusOffset); 
		setTimeout(Autocopy_DeselectAfterCopy_CollapseSelection, 100); 


	}
	else
	{	
		goDoCommand('cmd_selectNone');
	}
}
function Autocopy_DeselectAfterCopy_ExtendSelection(SelectionfocusNode, SelectionfocusOffset)
{
	var focusedWindow = document.commandDispatcher.focusedWindow;
	try
	{
		var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
		var Selection = winWrapper.getSelection();
	}
	catch(e)
	{
		var Selection = focusedWindow.getSelection();
	}
	Selection.extend(SelectionfocusNode, SelectionfocusOffset);
}
function Autocopy_DeselectAfterCopy_CollapseSelection()
{
	var focusedWindow = document.commandDispatcher.focusedWindow;
	try
	{
		var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
		var Selection = winWrapper.getSelection();
	}
	catch(e)
	{
		var Selection = focusedWindow.getSelection();
	}
	var SelectionanchorNode = Selection.anchorNode;
	var SelectionanchorOffset = Selection.anchorOffset;
	Selection.collapse(SelectionanchorNode, SelectionanchorOffset);
}




function AutocopyBlinkStatusbarButton(numberofblinks)
{
	setTimeout(AutocopyBlinkStatusbarButton, 5000, 0); //resets in 5 seconds just incase

	var autocopyStatusBarButton = document.getElementById('autocopy-status');
	var autocopyStatusBarButtonImage = document.getElementById('autocopy-status-image');
	var autocopyStatusBarButtonTooltip = document.getElementById('autocopy-tooltip-value');
	if (numberofblinks > 0)
	{
		if (autocopyPrefs.getIntPref("StatusBarState") != 0)
		{
			 if(autocopyPrefs.getBoolPref("optStatusBar")){
				if(autocopyStatusBarButtonImage.getAttribute("src") == "chrome://autocopy/skin/AutoCopyEnabled.png")
				{
					autocopyStatusBarButtonImage.setAttribute("src", "chrome://autocopy/skin/AutoCopyBlank.png");
				}
				else
				{
					autocopyStatusBarButtonImage.setAttribute("src", "chrome://autocopy/skin/AutoCopyEnabled.png");
				}
				numberofblinks = numberofblinks - 1;
		     		setTimeout(AutocopyBlinkStatusbarButton, 300, numberofblinks);
			 }
		}
	}
	else
	{
		if (autocopyPrefs.getIntPref("StatusBarState") != 0)
		{
			 if(autocopyPrefs.getBoolPref("optStatusBar")){
				autocopyStatusBarButtonImage.setAttribute("src", "chrome://autocopy/skin/AutoCopyEnabled.png");
			 }
		}
	}
}


function autocopy_getSelection() 
{
	var focusedElement = document.commandDispatcher.focusedElement;
	var SelectionText 
	if(focusedElement)
	{
		SelectionText = focusedElement.value.substring(focusedElement.selectionStart, focusedElement.selectionEnd);
	}
	else
	{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		try
		{
			var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
			var Selection = winWrapper.getSelection();
		}
		catch(e)
		{
			var Selection = focusedWindow.getSelection();
		}
		SelectionText = Selection.toString();

	}
	return SelectionText;
}

function autocopy_getClipboardContents()
{
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].
             getService(Components.interfaces.nsIClipboard);
	if (!clip) return false;

	var trans = Components.classes["@mozilla.org/widget/transferable;1"].
              createInstance(Components.interfaces.nsITransferable);
	if (!trans) return false;
		trans.addDataFlavor("text/unicode");

	clip.getData(trans,clip.kGlobalClipboard);

	var str = new Object();
	var strLength = new Object();

	try{
		trans.getTransferData("text/unicode",str,strLength);
	}
	catch(e){	
		return false;
	}
	if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) pastetext = str.data.substring(0,strLength.value / 2);
	
	return str;
}

function autocopy_setClipboardContents(copytext)
{	
	try{
		var str = Components.classes["@mozilla.org/supports-string;1"].
            createInstance(Components.interfaces.nsISupportsString);
		if (!str) return false;
		str.data = copytext;

		var trans = Components.classes["@mozilla.org/widget/transferable;1"].
              createInstance(Components.interfaces.nsITransferable);
		if (!trans) return false;

		trans.addDataFlavor("text/unicode");
		trans.setTransferData("text/unicode",str,copytext.length * 2);

		var clipid = Components.interfaces.nsIClipboard;
		var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
		if (!clip) return false;

		clip.setData(trans,null,clipid.kGlobalClipboard);
		return true;
	}
	catch(e)
	{
		return false;
	}
}



function autocopy_togglepasteonmiddleclick()
{
	PasteOnMiddleClickStatusbarOption =  document.getElementById('autocopy-statusbar-PasteOnMiddleClick');
	if(PasteOnMiddleClickStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optPasteOnMiddleClick"))
		{
			autocopyPrefs.setBoolPref("optPasteOnMiddleClick", false);
			PasteOnMiddleClickStatusbarOption.setAttribute("checked", false);
		}
		else
		{
			autocopyPrefs.setBoolPref("optPasteOnMiddleClick", true);
			PasteOnMiddleClickStatusbarOption.setAttribute("checked", true);
		}
	}
}

function autocopy_toggleEnableInTextBoxes()
{
	EnableInTextBoxesStatusbarOption =  document.getElementById('autocopy-statusbar-EnableInTextBoxes');
	if(EnableInTextBoxesStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
		{
			autocopyPrefs.setBoolPref("optEnableInTextBoxes", false);
			EnableInTextBoxesStatusbarOption.setAttribute("checked", false);
		}
		else
		{
			autocopyPrefs.setBoolPref("optEnableInTextBoxes", true);
			EnableInTextBoxesStatusbarOption.setAttribute("checked", true);
		}
	}
}


function autocopy_toggleStatusbarBlink()
{
	StatusbarBlinkStatusbarOption =  document.getElementById('autocopy-statusbar-StatusbarBlink');
	if(StatusbarBlinkStatusbarOption)
	{
		if (autocopyPrefs.getBoolPref("optStatusbarBlink"))
		{
			autocopyPrefs.setBoolPref("optStatusbarBlink", false);
			StatusbarBlinkStatusbarOption.setAttribute("checked", false);
		}
		else
		{
			autocopyPrefs.setBoolPref("optStatusbarBlink", true);
			StatusbarBlinkStatusbarOption.setAttribute("checked", true);
		}
	}
}

function autocopy_toggleDeselectAfterCopy()
{
	StatusbarDeselectAfterCopy =  document.getElementById('autocopy-statusbar-DeselectAfterCopy');
	if(StatusbarDeselectAfterCopy)
	{
		if (autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
		{
			autocopyPrefs.setBoolPref("optDeselectAfterCopy", false);
			StatusbarDeselectAfterCopy.setAttribute("checked", false);
		}
		else
		{
			autocopyPrefs.setBoolPref("optDeselectAfterCopy", true);
			StatusbarDeselectAfterCopy.setAttribute("checked", true);
		}
	}
}